/*
	Free for non-commercial use.
	Copyright 2006 by IceOnly
*/

#include "minilib/minimal.h"

// Konstanten
#define START_TIME 10
#define MIN_TIME 5
#define MAX_TIME 120

// Prototypen
void run_fgrab(int time);
void draw_screen(int time);

// Main
int main(int argc, char *argv[])
{
	gp2x_init(1000, 8, 11025,16,1,60, 1);

	int time = START_TIME;
	int old_time;
	bool done=false;

	while(!done)
	{
		unsigned long pad = gp2x_joystick_read();
		
		if(pad & GP2X_L)
			if(time-5 >= MIN_TIME)
			{
				time-=5;
				gp2x_timer_delay(500);
			}

		if(pad & GP2X_R)
			if(time+5 <= MAX_TIME)
			{
				time+=5;
				gp2x_timer_delay(500);
			}

		if(pad & GP2X_LEFT)
			if(time > MIN_TIME)
			{
				time--;
				gp2x_timer_delay(500);
			}

		if(pad & GP2X_RIGHT)
			if(time < MAX_TIME)
			{
				time++;
				gp2x_timer_delay(500);
			}

		if(old_time != time)
		{
			draw_screen(time);
			old_time=time;
		}

		if(pad & GP2X_X)
			done=true;
	
		if(pad & GP2X_SELECT)
			exit(0);
	}
	run_fgrab(time);
	exit(0);
}

// Sound 
void gp2x_sound_frame(void *blah, void *buff, int samples) {}

// ausgabe zeichnen
void draw_screen(int time)
{
	gp2x_printf(NULL,5,5,"fGrabber - A fGrab Frontend\n"
											 "---------------------------\n"
											 "written by IceOnly\n");
	
	gp2x_printf(NULL,5,50,"Timer: %d Sec  ", time);
	
	gp2x_printf(NULL,5,70,"* Drcke < oder > um den Timer zu ndern\n"
											  "* Drcke R oder L um den Timer um 5 Sec zu ndern\n"
											  "* Drcke X um zu starten\n"
											  "* Drcke SELECT um abzubrechen und\n"
												"  das Programm zu beenden\n");	
	
	gp2x_video_RGB_flip(0);
  return;
}

// fGrab starten
void run_fgrab(int time)
{
	char cmd[]="./fbgrab -s 5   screenshot.png > fbgrab.log &";
  int tmp;

  for(int i=12; i<15; i++)
  {
		if(time >= 100)
		{
			tmp=time/100;
  		cmd[i]=tmp+48;
  		time-=tmp*100;
		} 
		else if(time >= 10)
		{
			tmp=time/10;
  		cmd[i]=tmp+48;
  		time-=tmp*10;
		}
		else
		{
  		cmd[i]=time+48;
  		break;
		}
	}
  system(cmd);
  return;
}
